	include "p16f84.inc"

TEMP	EQU	0x0C
VAL	EQU	0x0D

	ORG 	0x0000
	BCF 	PCLATH,3
	BCF 	PCLATH,4
	GOTO 	START

	ORG 	0x0004		; gestione timer-overflow
	COMF	PORTA		; inverti il fronte
	MOVFW	VAL
	MOVWF	TMR0
	BCF	INTCON,T0IF	; ricarica il timer e resetta l'interrupt bit relativo
	RETFIE


;; Inizializzazione di registri, timer e porte

START:	BSF 	STATUS,RP0	
	MOVLW 	0xFF
	MOVWF 	TRISB			; PORTB valore in input
	CLRF	TRISA			; PORTA bit di output
	BCF 	OPTION_REG,T0CS		; TIMER0 come contatore 
	BCF 	OPTION_REG,PSA		
	BSF	OPTION_REG,PS0		; Prescaler 1:4
	BCF	OPTION_REG,PS1
	BCF	OPTION_REG,PS2
	BCF 	STATUS,RP0
	BSF	INTCON,T0IE		; TMR0 Interrupr Enable


;; Acquisizione di input dalla porta e aggiornamento del valore del timer

GRAB:	MOVFW	VAL	
	MOVWF	TEMP
	MOVFW	PORTB
	XORWF	TEMP
	INCF	TEMP
	DECFSZ	TEMP
	GOTO 	CHANGE
	GOTO	GRAB

CHANGE:	MOVWF	VAL
	MOVWF	TMR0
	GOTO 	GRAB

	END

	
